/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.116 Revision 1.162
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.116 2011/07/04 11:27:53 djc Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.162 2012/12/20 06:07:05 floppym Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Gentoo Python Project <python@gentoo.org> 7# Gentoo Python Project <python@gentoo.org>
8# @BLURB: Eclass for Python packages 8# @BLURB: Eclass for Python packages
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The python eclass contains miscellaneous, useful functions for Python packages. 10# The python eclass contains miscellaneous, useful functions for Python packages.
11 11
12if [[ ${_PYTHON_UTILS_R1} ]]; then
13 die 'python.eclass can not be used with python-r1 suite eclasses.'
14fi
15
16# Must call inherit before EXPORT_FUNCTIONS to avoid QA warning.
17if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
12inherit multilib 18 inherit multilib
19fi
13 20
21# Export pkg_setup every time to avoid issues with eclass inheritance order.
22if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
23 EXPORT_FUNCTIONS pkg_setup
24fi
25
26# Avoid processing this eclass more than once.
27if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
28_PYTHON_ECLASS_INHERITED="1"
29
14if ! has "${EAPI:-0}" 0 1 2 3; then 30if ! has "${EAPI:-0}" 0 1 2 3 4 5; then
15 die "API of python.eclass in EAPI=\"${EAPI}\" not established" 31 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16fi 32fi
17 33
18_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7) 34_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
19_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.0 3.1 3.2 3.3) 35_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.1 3.2 3.3)
20_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython) 36_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython)
37_PYPY_GLOBALLY_SUPPORTED_ABIS=(2.7-pypy-1.7 2.7-pypy-1.8 2.7-pypy-1.9 2.7-pypy-2.0)
21_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]}) 38_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]} ${_PYPY_GLOBALLY_SUPPORTED_ABIS[@]})
22 39
23# ================================================================================================ 40# ================================================================================================
24# ===================================== HANDLING OF METADATA ===================================== 41# ===================================== HANDLING OF METADATA =====================================
25# ================================================================================================ 42# ================================================================================================
43
44_PYTHON_ABI_PATTERN_REGEX="([[:alnum:]]|\.|-|\*|\[|\])+"
26 45
27_python_check_python_abi_matching() { 46_python_check_python_abi_matching() {
28 local pattern patterns patterns_list="0" PYTHON_ABI 47 local pattern patterns patterns_list="0" PYTHON_ABI
29 48
30 while (($#)); do 49 while (($#)); do
56 pattern="$2" 75 pattern="$2"
57 76
58 if [[ "${pattern}" == *"-cpython" ]]; then 77 if [[ "${pattern}" == *"-cpython" ]]; then
59 [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ && "${PYTHON_ABI}" == ${pattern%-cpython} ]] 78 [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ && "${PYTHON_ABI}" == ${pattern%-cpython} ]]
60 elif [[ "${pattern}" == *"-jython" ]]; then 79 elif [[ "${pattern}" == *"-jython" ]]; then
80 [[ "${PYTHON_ABI}" == ${pattern} ]]
81 elif [[ "${pattern}" == *"-pypy-"* ]]; then
61 [[ "${PYTHON_ABI}" == ${pattern} ]] 82 [[ "${PYTHON_ABI}" == ${pattern} ]]
62 else 83 else
63 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 84 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
64 [[ "${PYTHON_ABI}" == ${pattern} ]] 85 [[ "${PYTHON_ABI}" == ${pattern} ]]
65 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then 86 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
66 [[ "${PYTHON_ABI%-jython}" == ${pattern} ]] 87 [[ "${PYTHON_ABI%-jython}" == ${pattern} ]]
88 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-pypy-[[:digit:]]+\.[[:digit:]]+$ ]]; then
89 [[ "${PYTHON_ABI%-pypy-*}" == ${pattern} ]]
67 else 90 else
68 die "${FUNCNAME}(): Unrecognized Python ABI '${PYTHON_ABI}'" 91 die "${FUNCNAME}(): Unrecognized Python ABI '${PYTHON_ABI}'"
69 fi 92 fi
70 fi 93 fi
71 else 94 else
77 fi 100 fi
78 done <<< "${patterns}" 101 done <<< "${patterns}"
79 102
80 return 1 103 return 1
81 fi 104 fi
105}
106
107_python_implementation() {
108 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
109 return 0
110 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
111 return 0
112 elif [[ "${CATEGORY}/${PN}" == "dev-python/pypy" ]]; then
113 return 0
114 else
115 return 1
116 fi
117}
118
119_python_package_supporting_installation_for_multiple_python_abis() {
120 [[ -n "${SUPPORT_PYTHON_ABIS}" ]]
82} 121}
83 122
84# @ECLASS-VARIABLE: PYTHON_DEPEND 123# @ECLASS-VARIABLE: PYTHON_DEPEND
85# @DESCRIPTION: 124# @DESCRIPTION:
86# Specification of dependency on dev-lang/python. 125# Specification of dependency on dev-lang/python.
212 else 251 else
213 die "Invalid syntax of PYTHON_DEPEND" 252 die "Invalid syntax of PYTHON_DEPEND"
214 fi 253 fi
215} 254}
216 255
256if _python_implementation; then
217DEPEND=">=app-admin/eselect-python-20091230" 257 DEPEND=">=app-admin/eselect-python-20091230"
218RDEPEND="${DEPEND}" 258 RDEPEND="${DEPEND}"
259 PDEPEND="app-admin/python-updater"
260fi
219 261
220if [[ -n "${PYTHON_DEPEND}" ]]; then 262if [[ -n "${PYTHON_DEPEND}" ]]; then
221 _python_parse_PYTHON_DEPEND 263 _python_parse_PYTHON_DEPEND
222else 264else
223 _PYTHON_ATOMS=("dev-lang/python") 265 _PYTHON_ATOMS=("dev-lang/python")
262 _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}" 304 _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}"
263 fi 305 fi
264 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then 306 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then
265 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )" 307 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )"
266 fi 308 fi
267 DEPEND+=" ${_PYTHON_USE_WITH_ATOMS}" 309 DEPEND+="${DEPEND:+ }${_PYTHON_USE_WITH_ATOMS}"
268 RDEPEND+=" ${_PYTHON_USE_WITH_ATOMS}" 310 RDEPEND+="${RDEPEND:+ }${_PYTHON_USE_WITH_ATOMS}"
269 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY 311 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY
270fi 312fi
271 313
272unset _PYTHON_ATOMS 314unset _PYTHON_ATOMS
273 315
274# ================================================================================================ 316# ================================================================================================
275# =================================== MISCELLANEOUS FUNCTIONS ==================================== 317# =================================== MISCELLANEOUS FUNCTIONS ====================================
276# ================================================================================================ 318# ================================================================================================
277
278_python_implementation() {
279 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
280 return 0
281 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
282 return 0
283 else
284 return 1
285 fi
286}
287
288_python_package_supporting_installation_for_multiple_python_abis() {
289 if [[ "${EBUILD_PHASE}" == "depend" ]]; then
290 die "${FUNCNAME}() cannot be used in global scope"
291 fi
292
293 if has "${EAPI:-0}" 0 1 2 3 4; then
294 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
295 return 0
296 else
297 return 1
298 fi
299 else
300 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
301 fi
302}
303 319
304_python_abi-specific_local_scope() { 320_python_abi-specific_local_scope() {
305 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]] 321 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]]
306} 322}
307 323
379 _CYAN= 395 _CYAN=
380 _NORMAL= 396 _NORMAL=
381 fi 397 fi
382} 398}
383 399
384unset PYTHON_PKG_SETUP_EXECUTED
385
386_python_check_python_pkg_setup_execution() { 400_python_check_python_pkg_setup_execution() {
387 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return 401 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return
388 402
389 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then 403 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then
390 die "python_pkg_setup() not called" 404 die "python_pkg_setup() not called"
458 fi 472 fi
459 473
460 PYTHON_PKG_SETUP_EXECUTED="1" 474 PYTHON_PKG_SETUP_EXECUTED="1"
461} 475}
462 476
463if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
464 EXPORT_FUNCTIONS pkg_setup
465fi
466
467_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|python)' 477_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|pypy-c|python)'
468 478
469# @FUNCTION: python_convert_shebangs 479# @FUNCTION: python_convert_shebangs
470# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories] 480# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories]
471# @DESCRIPTION: 481# @DESCRIPTION:
472# Convert shebangs in specified files. Directories can be specified only with --recursive option. 482# Convert shebangs in specified files. Directories can be specified only with --recursive option.
473python_convert_shebangs() { 483python_convert_shebangs() {
474 _python_check_python_pkg_setup_execution 484 _python_check_python_pkg_setup_execution
475 485
476 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" 486 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" shebangs_converted="0"
477 487
478 while (($#)); do 488 while (($#)); do
479 case "$1" in 489 case "$1" in
480 -r|--recursive) 490 -r|--recursive)
481 recursive="1" 491 recursive="1"
536 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue 546 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
537 547
538 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then 548 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then
539 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue 549 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
540 550
551 shebangs_converted="1"
552
541 if [[ "${quiet}" == "0" ]]; then 553 if [[ "${quiet}" == "0" ]]; then
542 einfo "Converting shebang in '${file}'" 554 einfo "Converting shebang in '${file}'"
543 fi 555 fi
544 556
545 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed" 557 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|pypy-c\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
558 fi
559 done
560
561 if [[ "${shebangs_converted}" == "0" ]]; then
562 ewarn "${FUNCNAME}(): Python scripts not found"
546 fi 563 fi
564}
565
566# @FUNCTION: python_clean_py-compile_files
567# @USAGE: [-q|--quiet]
568# @DESCRIPTION:
569# Clean py-compile files to disable byte-compilation.
570python_clean_py-compile_files() {
571 _python_check_python_pkg_setup_execution
572
573 local file files=() quiet="0"
574
575 while (($#)); do
576 case "$1" in
577 -q|--quiet)
578 quiet="1"
579 ;;
580 -*)
581 die "${FUNCNAME}(): Unrecognized option '$1'"
582 ;;
583 *)
584 die "${FUNCNAME}(): Invalid usage"
585 ;;
586 esac
587 shift
588 done
589
590 while read -d $'\0' -r file; do
591 files+=("${file#./}")
592 done < <(find -name py-compile -type f -print0)
593
594 for file in "${files[@]}"; do
595 if [[ "${quiet}" == "0" ]]; then
596 einfo "Cleaning '${file}' file"
597 fi
598 echo "#!/bin/sh" > "${file}"
547 done 599 done
548} 600}
549 601
550# @FUNCTION: python_clean_installation_image 602# @FUNCTION: python_clean_installation_image
551# @USAGE: [-q|--quiet] 603# @USAGE: [-q|--quiet]
694 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then 746 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then
695 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install 747 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install
696 fi 748 fi
697fi 749fi
698 750
699if has "${EAPI:-0}" 0 1 2 3 4; then
700 unset PYTHON_ABIS 751unset PYTHON_ABIS
701fi
702 752
703_python_calculate_PYTHON_ABIS() { 753_python_calculate_PYTHON_ABIS() {
704 if ! _python_package_supporting_installation_for_multiple_python_abis; then 754 if ! _python_package_supporting_installation_for_multiple_python_abis; then
705 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 755 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
706 fi 756 fi
707 757
708 _python_initial_sanity_checks 758 _python_initial_sanity_checks
709 759
710 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then 760 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]]; then
711 local PYTHON_ABI restricted_ABI restricted_ABIs support_ABI supported_PYTHON_ABIS 761 local PYTHON_ABI
712
713 restricted_ABIs="${RESTRICT_PYTHON_ABIS// /$'\n'}"
714 762
715 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then 763 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
716 local cpython_enabled="0" 764 local cpython_enabled="0"
717 765
718 if [[ -z "${USE_PYTHON}" ]]; then 766 if [[ -z "${USE_PYTHON}" ]]; then
726 774
727 if has "${PYTHON_ABI}" "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; then 775 if has "${PYTHON_ABI}" "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; then
728 cpython_enabled="1" 776 cpython_enabled="1"
729 fi 777 fi
730 778
731 support_ABI="1"
732 while read restricted_ABI; do
733 if _python_check_python_abi_matching "${PYTHON_ABI}" "${restricted_ABI}"; then 779 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
734 support_ABI="0" 780 export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
735 break
736 fi 781 fi
737 done <<< "${restricted_ABIs}"
738 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
739 done 782 done
740 783
741 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then 784 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
742 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}" 785 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}"
743 fi 786 fi
759 die "'${EPREFIX}/usr/bin/python2' is not valid symlink" 802 die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
760 fi 803 fi
761 804
762 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')" 805 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
763 806
807 support_python_major_version="0"
764 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do 808 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
809 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
765 support_python_major_version="1" 810 support_python_major_version="1"
766 while read restricted_ABI; do 811 break
767 if _python_check_python_abi_matching "${PYTHON_ABI}" "${restricted_ABI}"; then
768 support_python_major_version="0"
769 fi 812 fi
770 done <<< "${restricted_ABIs}"
771 [[ "${support_python_major_version}" == "1" ]] && break
772 done 813 done
773 if [[ "${support_python_major_version}" == "1" ]]; then 814 if [[ "${support_python_major_version}" == "1" ]]; then
774 while read restricted_ABI; do
775 if _python_check_python_abi_matching "${python2_version}" "${restricted_ABI}"; then 815 if _python_check_python_abi_matching --patterns-list "${python2_version}" "${RESTRICT_PYTHON_ABIS}"; then
776 die "Active version of CPython 2 is not supported by ${CATEGORY}/${PF}" 816 die "Active version of CPython 2 is not supported by ${CATEGORY}/${PF}"
777 fi 817 fi
778 done <<< "${restricted_ABIs}"
779 else 818 else
780 python2_version="" 819 python2_version=""
781 fi 820 fi
782 fi 821 fi
783 822
786 die "'${EPREFIX}/usr/bin/python3' is not valid symlink" 825 die "'${EPREFIX}/usr/bin/python3' is not valid symlink"
787 fi 826 fi
788 827
789 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')" 828 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
790 829
830 support_python_major_version="0"
791 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do 831 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
832 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
792 support_python_major_version="1" 833 support_python_major_version="1"
793 while read restricted_ABI; do 834 break
794 if _python_check_python_abi_matching "${PYTHON_ABI}" "${restricted_ABI}"; then
795 support_python_major_version="0"
796 fi 835 fi
797 done <<< "${restricted_ABIs}"
798 [[ "${support_python_major_version}" == "1" ]] && break
799 done 836 done
800 if [[ "${support_python_major_version}" == "1" ]]; then 837 if [[ "${support_python_major_version}" == "1" ]]; then
801 while read restricted_ABI; do
802 if _python_check_python_abi_matching "${python3_version}" "${restricted_ABI}"; then 838 if _python_check_python_abi_matching --patterns-list "${python3_version}" "${RESTRICT_PYTHON_ABIS}"; then
803 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}" 839 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}"
804 fi 840 fi
805 done <<< "${restricted_ABIs}"
806 else 841 else
807 python3_version="" 842 python3_version=""
808 fi 843 fi
844 fi
845
846 if [[ -z "${python2_version}" && -z "${python3_version}" ]]; then
847 eerror "${CATEGORY}/${PF} requires at least one of the following packages:"
848 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
849 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
850 eerror " dev-lang/python:${PYTHON_ABI}"
851 fi
852 done
853 die "No supported version of CPython installed"
809 fi 854 fi
810 855
811 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then 856 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then
812 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink" 857 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink"
813 eerror "is set incorrectly. Use \`eselect python\` to fix configuration." 858 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
835 eval "_PYTHON_SAVED_${variable}=\"\${!variable}\"" 880 eval "_PYTHON_SAVED_${variable}=\"\${!variable}\""
836 for prefix in PYTHON_USER_ PYTHON_; do 881 for prefix in PYTHON_USER_ PYTHON_; do
837 if [[ "$(declare -p ${prefix}${variable} 2> /dev/null)" == "declare -a ${prefix}${variable}="* ]]; then 882 if [[ "$(declare -p ${prefix}${variable} 2> /dev/null)" == "declare -a ${prefix}${variable}="* ]]; then
838 eval "array=(\"\${${prefix}${variable}[@]}\")" 883 eval "array=(\"\${${prefix}${variable}[@]}\")"
839 for element in "${array[@]}"; do 884 for element in "${array[@]}"; do
840 if [[ "${element}" =~ ^([[:alnum:]]|\.|-|\*|\[|\])+\ (\+|-)\ .+ ]]; then 885 if [[ "${element}" =~ ^${_PYTHON_ABI_PATTERN_REGEX}\ (\+|-)\ .+ ]]; then
841 pattern="${element%% *}" 886 pattern="${element%% *}"
842 element="${element#* }" 887 element="${element#* }"
843 operator="${element%% *}" 888 operator="${element%% *}"
844 flags="${element#* }" 889 flags="${element#* }"
845 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then 890 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
971 python_default_function() { 1016 python_default_function() {
972 emake "$@" 1017 emake "$@"
973 } 1018 }
974 elif [[ "${EBUILD_PHASE}" == "test" ]]; then 1019 elif [[ "${EBUILD_PHASE}" == "test" ]]; then
975 python_default_function() { 1020 python_default_function() {
1021 # Stolen from portage's _eapi0_src_test()
1022 local emake_cmd="${MAKE:-make} ${MAKEOPTS} ${EXTRA_EMAKE}"
976 if emake -j1 -n check &> /dev/null; then 1023 if ${emake_cmd} -j1 -n check &> /dev/null; then
977 emake -j1 check "$@" 1024 ${emake_cmd} -j1 check "$@"
978 elif emake -j1 -n test &> /dev/null; then 1025 elif ${emake_cmd} -j1 -n test &> /dev/null; then
979 emake -j1 test "$@" 1026 ${emake_cmd} -j1 test "$@"
980 fi 1027 fi
981 } 1028 }
982 elif [[ "${EBUILD_PHASE}" == "install" ]]; then 1029 elif [[ "${EBUILD_PHASE}" == "install" ]]; then
983 python_default_function() { 1030 python_default_function() {
984 emake DESTDIR="${D}" install "$@" 1031 emake DESTDIR="${D}" install "$@"
1015 iterated_PYTHON_ABIS="${PYTHON_ABIS}" 1062 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
1016 fi 1063 fi
1017 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 1064 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
1018 if [[ "${EBUILD_PHASE}" == "test" ]] && _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${PYTHON_TESTS_RESTRICTED_ABIS}"; then 1065 if [[ "${EBUILD_PHASE}" == "test" ]] && _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${PYTHON_TESTS_RESTRICTED_ABIS}"; then
1019 if [[ "${quiet}" == "0" ]]; then 1066 if [[ "${quiet}" == "0" ]]; then
1020 echo " ${_GREEN}*${_NORMAL} ${_BLUE}Testing of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version) skipped${_NORMAL}" 1067 echo " ${_GREEN}*${_NORMAL} ${_BLUE}Testing of ${CATEGORY}/${PF} with $(python_get_implementation_and_version) skipped${_NORMAL}"
1021 fi 1068 fi
1022 continue 1069 continue
1023 fi 1070 fi
1024 1071
1025 _python_prepare_flags 1072 _python_prepare_flags
1026 1073
1027 if [[ "${quiet}" == "0" ]]; then 1074 if [[ "${quiet}" == "0" ]]; then
1028 if [[ -n "${action_message_template}" ]]; then 1075 if [[ -n "${action_message_template}" ]]; then
1029 eval "action_message=\"${action_message_template}\"" 1076 eval "action_message=\"${action_message_template}\""
1030 else 1077 else
1031 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version)..." 1078 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation_and_version)..."
1032 fi 1079 fi
1033 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}" 1080 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}"
1034 fi 1081 fi
1035 1082
1036 if [[ "${separate_build_dirs}" == "1" ]]; then 1083 if [[ "${separate_build_dirs}" == "1" ]]; then
1060 1107
1061 if [[ "${return_code}" -ne 0 ]]; then 1108 if [[ "${return_code}" -ne 0 ]]; then
1062 if [[ -n "${failure_message_template}" ]]; then 1109 if [[ -n "${failure_message_template}" ]]; then
1063 eval "failure_message=\"${failure_message_template}\"" 1110 eval "failure_message=\"${failure_message_template}\""
1064 else 1111 else
1065 failure_message="${action} failed with $(python_get_implementation) $(python_get_version) in ${function}() function" 1112 failure_message="${action} failed with $(python_get_implementation_and_version) in ${function}() function"
1066 fi 1113 fi
1067 1114
1068 if [[ "${nonfatal}" == "1" ]]; then 1115 if [[ "${nonfatal}" == "1" ]]; then
1069 if [[ "${quiet}" == "0" ]]; then 1116 if [[ "${quiet}" == "0" ]]; then
1070 ewarn "${failure_message}" 1117 ewarn "${failure_message}"
1241import os 1288import os
1242import re 1289import re
1243import subprocess 1290import subprocess
1244import sys 1291import sys
1245 1292
1246cpython_re = re.compile(r"^python(\d+\.\d+)$") 1293cpython_ABI_re = re.compile(r"^(\d+\.\d+)$")
1294jython_ABI_re = re.compile(r"^(\d+\.\d+)-jython$")
1295pypy_ABI_re = re.compile(r"^\d+\.\d+-pypy-(\d+\.\d+)$")
1296cpython_interpreter_re = re.compile(r"^python(\d+\.\d+)$")
1247jython_re = re.compile(r"^jython(\d+\.\d+)$") 1297jython_interpreter_re = re.compile(r"^jython(\d+\.\d+)$")
1298pypy_interpreter_re = re.compile(r"^pypy-c(\d+\.\d+)$")
1248python_shebang_re = re.compile(r"^#! *(${EPREFIX}/usr/bin/python|(${EPREFIX})?/usr/bin/env +(${EPREFIX}/usr/bin/)?python)") 1299cpython_shebang_re = re.compile(r"^#![ \t]*(?:${EPREFIX}/usr/bin/python|(?:${EPREFIX})?/usr/bin/env[ \t]+(?:${EPREFIX}/usr/bin/)?python)")
1300python_shebang_options_re = re.compile(r"^#![ \t]*${EPREFIX}/usr/bin/(?:jython|pypy-c|python)(?:\d+(?:\.\d+)?)?[ \t]+(-\S)")
1249python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$") 1301python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
1250 1302
1251def get_PYTHON_ABI(EPYTHON): 1303pypy_versions_mapping = {
1252 cpython_matched = cpython_re.match(EPYTHON) 1304 "1.5": "2.7",
1253 jython_matched = jython_re.match(EPYTHON) 1305 "1.6": "2.7",
1306 "1.7": "2.7",
1307 "1.8": "2.7",
1308 "1.9": "2.7",
1309}
1310
1311def get_PYTHON_ABI(python_interpreter):
1312 cpython_matched = cpython_interpreter_re.match(python_interpreter)
1313 jython_matched = jython_interpreter_re.match(python_interpreter)
1314 pypy_matched = pypy_interpreter_re.match(python_interpreter)
1254 if cpython_matched is not None: 1315 if cpython_matched is not None:
1255 PYTHON_ABI = cpython_matched.group(1) 1316 PYTHON_ABI = cpython_matched.group(1)
1256 elif jython_matched is not None: 1317 elif jython_matched is not None:
1257 PYTHON_ABI = jython_matched.group(1) + "-jython" 1318 PYTHON_ABI = jython_matched.group(1) + "-jython"
1319 elif pypy_matched is not None:
1320 PYTHON_ABI = pypy_versions_mapping[pypy_matched.group(1)] + "-pypy-" + pypy_matched.group(1)
1258 else: 1321 else:
1259 PYTHON_ABI = None 1322 PYTHON_ABI = None
1260 return PYTHON_ABI 1323 return PYTHON_ABI
1261 1324
1325def get_python_interpreter(PYTHON_ABI):
1326 cpython_matched = cpython_ABI_re.match(PYTHON_ABI)
1327 jython_matched = jython_ABI_re.match(PYTHON_ABI)
1328 pypy_matched = pypy_ABI_re.match(PYTHON_ABI)
1329 if cpython_matched is not None:
1330 python_interpreter = "python" + cpython_matched.group(1)
1331 elif jython_matched is not None:
1332 python_interpreter = "jython" + jython_matched.group(1)
1333 elif pypy_matched is not None:
1334 python_interpreter = "pypy-c" + pypy_matched.group(1)
1335 else:
1336 python_interpreter = None
1337 return python_interpreter
1338
1262EOF 1339EOF
1263 if [[ "$?" != "0" ]]; then 1340 if [[ "$?" != "0" ]]; then
1264 die "${FUNCNAME}(): Generation of '$1' failed" 1341 die "${FUNCNAME}(): Generation of '$1' failed"
1265 fi 1342 fi
1266 if [[ "${respect_EPYTHON}" == "1" ]]; then 1343 if [[ "${respect_EPYTHON}" == "1" ]]; then
1267 cat << EOF >> "${file}" 1344 cat << EOF >> "${file}"
1268EPYTHON = os.environ.get("EPYTHON") 1345python_interpreter = os.environ.get("EPYTHON")
1269if EPYTHON: 1346if python_interpreter:
1270 PYTHON_ABI = get_PYTHON_ABI(EPYTHON) 1347 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1271 if PYTHON_ABI is None: 1348 if PYTHON_ABI is None:
1272 sys.stderr.write("EPYTHON variable has unrecognized value '%s'\n" % EPYTHON) 1349 sys.stderr.write("%s: EPYTHON variable has unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1273 sys.exit(1) 1350 sys.exit(1)
1274else: 1351else:
1275 try: 1352 try:
1353 environment = os.environ.copy()
1354 environment["ROOT"] = "/"
1276 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE) 1355 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1277 if eselect_process.wait() != 0: 1356 if eselect_process.wait() != 0:
1278 raise ValueError 1357 raise ValueError
1279 except (OSError, ValueError): 1358 except (OSError, ValueError):
1280 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 1359 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1281 sys.exit(1) 1360 sys.exit(1)
1282 1361
1283 EPYTHON = eselect_process.stdout.read() 1362 python_interpreter = eselect_process.stdout.read()
1284 if not isinstance(EPYTHON, str): 1363 if not isinstance(python_interpreter, str):
1285 # Python 3 1364 # Python 3
1286 EPYTHON = EPYTHON.decode() 1365 python_interpreter = python_interpreter.decode()
1287 EPYTHON = EPYTHON.rstrip("\n") 1366 python_interpreter = python_interpreter.rstrip("\n")
1288 1367
1289 PYTHON_ABI = get_PYTHON_ABI(EPYTHON) 1368 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1290 if PYTHON_ABI is None: 1369 if PYTHON_ABI is None:
1291 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON) 1370 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1292 sys.exit(1) 1371 sys.exit(1)
1293 1372
1294wrapper_script_path = os.path.realpath(sys.argv[0]) 1373wrapper_script_path = os.path.realpath(sys.argv[0])
1295target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI) 1374target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1296if not os.path.exists(target_executable_path): 1375if not os.path.exists(target_executable_path):
1297 sys.stderr.write("'%s' does not exist\n" % target_executable_path) 1376 sys.stderr.write("%s: '%s' does not exist\n" % (sys.argv[0], target_executable_path))
1298 sys.exit(1) 1377 sys.exit(1)
1299EOF 1378EOF
1300 if [[ "$?" != "0" ]]; then 1379 if [[ "$?" != "0" ]]; then
1301 die "${FUNCNAME}(): Generation of '$1' failed" 1380 die "${FUNCNAME}(): Generation of '$1' failed"
1302 fi 1381 fi
1303 else 1382 else
1304 cat << EOF >> "${file}" 1383 cat << EOF >> "${file}"
1305try: 1384try:
1385 environment = os.environ.copy()
1386 environment["ROOT"] = "/"
1306 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE) 1387 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1307 if eselect_process.wait() != 0: 1388 if eselect_process.wait() != 0:
1308 raise ValueError 1389 raise ValueError
1309except (OSError, ValueError): 1390except (OSError, ValueError):
1310 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 1391 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1311 sys.exit(1) 1392 sys.exit(1)
1312 1393
1313EPYTHON = eselect_process.stdout.read() 1394python_interpreter = eselect_process.stdout.read()
1314if not isinstance(EPYTHON, str): 1395if not isinstance(python_interpreter, str):
1315 # Python 3 1396 # Python 3
1316 EPYTHON = EPYTHON.decode() 1397 python_interpreter = python_interpreter.decode()
1317EPYTHON = EPYTHON.rstrip("\n") 1398python_interpreter = python_interpreter.rstrip("\n")
1318 1399
1319PYTHON_ABI = get_PYTHON_ABI(EPYTHON) 1400PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1320if PYTHON_ABI is None: 1401if PYTHON_ABI is None:
1321 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON) 1402 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1322 sys.exit(1) 1403 sys.exit(1)
1323 1404
1324wrapper_script_path = os.path.realpath(sys.argv[0]) 1405wrapper_script_path = os.path.realpath(sys.argv[0])
1325for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]: 1406for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]:
1326 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI) 1407 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1327 if os.path.exists(target_executable_path): 1408 if os.path.exists(target_executable_path):
1328 break 1409 break
1329else: 1410else:
1330 sys.stderr.write("No target script exists for '%s'\n" % wrapper_script_path) 1411 sys.stderr.write("%s: No target script exists for '%s'\n" % (sys.argv[0], wrapper_script_path))
1412 sys.exit(1)
1413
1414python_interpreter = get_python_interpreter(PYTHON_ABI)
1415if python_interpreter is None:
1416 sys.stderr.write("%s: Unrecognized Python ABI '%s'\n" % (sys.argv[0], PYTHON_ABI))
1331 sys.exit(1) 1417 sys.exit(1)
1332EOF 1418EOF
1333 if [[ "$?" != "0" ]]; then 1419 if [[ "$?" != "0" ]]; then
1334 die "${FUNCNAME}(): Generation of '$1' failed" 1420 die "${FUNCNAME}(): Generation of '$1' failed"
1335 fi 1421 fi
1336 fi 1422 fi
1337 cat << EOF >> "${file}" 1423 cat << EOF >> "${file}"
1338 1424
1339target_executable = open(target_executable_path, "rb") 1425target_executable = open(target_executable_path, "rb")
1340target_executable_first_line = target_executable.readline() 1426target_executable_first_line = target_executable.readline()
1427target_executable.close()
1341if not isinstance(target_executable_first_line, str): 1428if not isinstance(target_executable_first_line, str):
1342 # Python 3 1429 # Python 3
1343 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace") 1430 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace")
1344 1431
1432options = []
1433python_shebang_options_matched = python_shebang_options_re.match(target_executable_first_line)
1434if python_shebang_options_matched is not None:
1435 options = [python_shebang_options_matched.group(1)]
1436
1345python_shebang_matched = python_shebang_re.match(target_executable_first_line) 1437cpython_shebang_matched = cpython_shebang_re.match(target_executable_first_line)
1346target_executable.close()
1347 1438
1348if python_shebang_matched is not None: 1439if cpython_shebang_matched is not None:
1349 try: 1440 try:
1350 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % EPYTHON 1441 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % python_interpreter
1351 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1" 1442 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1"
1352 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE) 1443 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE)
1353 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] 1444 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
1354 if python_verification_process.wait() != 0: 1445 if python_verification_process.wait() != 0:
1355 raise ValueError 1446 raise ValueError
1360 python_verification_output = python_verification_output.decode() 1451 python_verification_output = python_verification_output.decode()
1361 1452
1362 if not python_verification_output_re.match(python_verification_output): 1453 if not python_verification_output_re.match(python_verification_output):
1363 raise ValueError 1454 raise ValueError
1364 1455
1365 if cpython_re.match(EPYTHON) is not None: 1456 if cpython_interpreter_re.match(python_interpreter) is not None:
1366 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0]) 1457 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
1367 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0] 1458 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
1368 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path 1459 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
1369 1460
1370 if hasattr(os, "execv"): 1461 if hasattr(os, "execv"):
1371 os.execv(python_interpreter_path, [python_interpreter_path] + sys.argv) 1462 os.execv(python_interpreter_path, [python_interpreter_path] + options + sys.argv)
1372 else: 1463 else:
1373 sys.exit(subprocess.Popen([python_interpreter_path] + sys.argv).wait()) 1464 sys.exit(subprocess.Popen([python_interpreter_path] + options + sys.argv).wait())
1374 except (KeyboardInterrupt, SystemExit): 1465 except (KeyboardInterrupt, SystemExit):
1375 raise 1466 raise
1376 except: 1467 except:
1377 pass 1468 pass
1378 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"): 1469 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"):
1420 fi 1511 fi
1421 1512
1422 _python_check_python_pkg_setup_execution 1513 _python_check_python_pkg_setup_execution
1423 _python_initialize_prefix_variables 1514 _python_initialize_prefix_variables
1424 1515
1425 local b file files=() intermediate_installation_images_directory PYTHON_ABI quiet="0" regex shebang version_executable wrapper_scripts=() wrapper_scripts_set=() 1516 local absolute_file b file files=() intermediate_installation_images_directory PYTHON_ABI quiet="0" regex shebang version_executable wrapper_scripts=() wrapper_scripts_set=()
1426 1517
1427 while (($#)); do 1518 while (($#)); do
1428 case "$1" in 1519 case "$1" in
1429 -q|--quiet) 1520 -q|--quiet)
1430 quiet="1" 1521 quiet="1"
1512 break 1603 break
1513 fi 1604 fi
1514 done 1605 done
1515 fi 1606 fi
1516 1607
1517 [[ "${version_executable}" == "0" || ! -x "${file}" ]] && continue 1608 [[ "${version_executable}" == "0" ]] && continue
1518 1609
1610 if [[ -L "${file}" ]]; then
1611 absolute_file="$(readlink "${file}")"
1612 if [[ "${absolute_file}" == /* ]]; then
1613 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${absolute_file##/}"
1614 else
1615 if [[ "${file}" == */* ]]; then
1616 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${file%/*}/${absolute_file}"
1617 else
1618 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${absolute_file}"
1619 fi
1620 fi
1621 else
1622 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${file}"
1623 fi
1624
1625 [[ ! -x "${absolute_file}" ]] && continue
1626
1519 shebang="$(head -n1 "${file}")" || die "Extraction of shebang from '${file}' failed" 1627 shebang="$(head -n1 "${absolute_file}")" || die "Extraction of shebang from '${absolute_file}' failed"
1520 1628
1521 if [[ "${version_executable}" == "2" ]]; then 1629 if [[ "${version_executable}" == "2" ]]; then
1522 wrapper_scripts+=("${ED}${file}") 1630 wrapper_scripts+=("${ED}${file}")
1523 elif [[ "${version_executable}" == "1" ]]; then 1631 elif [[ "${version_executable}" == "1" ]]; then
1524 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}([[:digit:]]+(\.[[:digit:]]+)?)?($|[[:space:]]+) ]]; then 1632 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}([[:digit:]]+(\.[[:digit:]]+)?)?($|[[:space:]]+) ]]; then
1535 fi 1643 fi
1536 1644
1537 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed" 1645 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed"
1538 1646
1539 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}[[:digit:]]*($|[[:space:]]+) ]]; then 1647 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}[[:digit:]]*($|[[:space:]]+) ]]; then
1648 if [[ -L "${file}-${PYTHON_ABI}" ]]; then
1649 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${absolute_file}"
1650 else
1540 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${file}-${PYTHON_ABI}" 1651 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${file}-${PYTHON_ABI}"
1652 fi
1541 fi 1653 fi
1542 done 1654 done
1543 1655
1544 popd > /dev/null || die "popd failed" 1656 popd > /dev/null || die "popd failed"
1545 1657
1658 # This is per bug #390691, without the duplication refactor, and with
1659 # the 3-way structure per comment #6. This enable users with old
1660 # coreutils to upgrade a lot easier (you need to upgrade python+portage
1661 # before coreutils can be upgraded).
1662 if ROOT="/" has_version '>=sys-apps/coreutils-6.9.90'; then
1663 cp -fr --preserve=all --no-preserve=context "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1546 if ROOT="/" has_version sys-apps/coreutils; then 1664 elif ROOT="/" has_version sys-apps/coreutils; then
1547 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed" 1665 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1548 else 1666 else
1549 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed" 1667 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1550 fi 1668 fi
1551 done 1669 done
1570 stdout = sys.stdout.buffer 1688 stdout = sys.stdout.buffer
1571else: 1689else:
1572 # Python 2 1690 # Python 2
1573 stdout = sys.stdout 1691 stdout = sys.stdout
1574 1692
1693python_wrapper_scripts_file = open('${T}/python_wrapper_scripts', 'rb')
1575files = set(open('${T}/python_wrapper_scripts', 'rb').read().rstrip(${b}'\x00').split(${b}'\x00')) 1694files = set(python_wrapper_scripts_file.read().rstrip(${b}'\x00').split(${b}'\x00'))
1695python_wrapper_scripts_file.close()
1576 1696
1577for file in sorted(files): 1697for file in sorted(files):
1578 stdout.write(file) 1698 stdout.write(file)
1579 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts") 1699 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts")
1580 1700
1645 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable. 1765 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
1646 PYTHON_REQUESTED_ACTIVE_VERSION="$1" 1766 PYTHON_REQUESTED_ACTIVE_VERSION="$1"
1647} 1767}
1648 1768
1649# @FUNCTION: python_need_rebuild 1769# @FUNCTION: python_need_rebuild
1770# @DESCRIPTION:
1650# @DESCRIPTION: Mark current package for rebuilding by python-updater after 1771# Mark current package for rebuilding by python-updater after
1651# switching of active version of Python. 1772# switching of active version of Python.
1652python_need_rebuild() { 1773python_need_rebuild() {
1653 if _python_package_supporting_installation_for_multiple_python_abis; then 1774 if _python_package_supporting_installation_for_multiple_python_abis; then
1654 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs" 1775 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1655 fi 1776 fi
1665 1786
1666# ================================================================================================ 1787# ================================================================================================
1667# ======================================= GETTER FUNCTIONS ======================================= 1788# ======================================= GETTER FUNCTIONS =======================================
1668# ================================================================================================ 1789# ================================================================================================
1669 1790
1670_PYTHON_ABI_EXTRACTION_COMMAND='import platform 1791_PYTHON_ABI_EXTRACTION_COMMAND=\
1792'import platform
1671import sys 1793import sys
1672sys.stdout.write(".".join(str(x) for x in sys.version_info[:2])) 1794sys.stdout.write(".".join(str(x) for x in sys.version_info[:2]))
1673if platform.system()[:4] == "Java": 1795if platform.system()[:4] == "Java":
1674 sys.stdout.write("-jython")' 1796 sys.stdout.write("-jython")
1797elif hasattr(platform, "python_implementation") and platform.python_implementation() == "PyPy":
1798 sys.stdout.write("-pypy-" + ".".join(str(x) for x in sys.pypy_version_info[:2]))'
1675 1799
1676_python_get_implementation() { 1800_python_get_implementation() {
1677 local ignore_invalid="0" 1801 local ignore_invalid="0"
1678 1802
1679 while (($#)); do 1803 while (($#)); do
1701 1825
1702 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 1826 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
1703 echo "CPython" 1827 echo "CPython"
1704 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then 1828 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
1705 echo "Jython" 1829 echo "Jython"
1830 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-pypy-[[:digit:]]+\.[[:digit:]]+$ ]]; then
1831 echo "PyPy"
1706 else 1832 else
1707 if [[ "${ignore_invalid}" == "0" ]]; then 1833 if [[ "${ignore_invalid}" == "0" ]]; then
1708 die "${FUNCNAME}(): Unrecognized Python ABI '$1'" 1834 die "${FUNCNAME}(): Unrecognized Python ABI '$1'"
1709 fi 1835 fi
1710 fi 1836 fi
1773 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1899 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1774 fi 1900 fi
1775 _python_calculate_PYTHON_ABIS 1901 _python_calculate_PYTHON_ABIS
1776 PYTHON_ABI="${PYTHON_ABIS##* }" 1902 PYTHON_ABI="${PYTHON_ABIS##* }"
1777 elif [[ "${python2}" == "1" ]]; then 1903 elif [[ "${python2}" == "1" ]]; then
1778 PYTHON_ABI="$(eselect python show --python2 --ABI)" 1904 PYTHON_ABI="$(ROOT="/" eselect python show --python2 --ABI)"
1779 if [[ -z "${PYTHON_ABI}" ]]; then 1905 if [[ -z "${PYTHON_ABI}" ]]; then
1780 die "${FUNCNAME}(): Active version of CPython 2 not set" 1906 die "${FUNCNAME}(): Active version of CPython 2 not set"
1781 elif [[ "${PYTHON_ABI}" != "2."* ]]; then 1907 elif [[ "${PYTHON_ABI}" != "2."* ]]; then
1782 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`" 1908 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
1783 fi 1909 fi
1784 elif [[ "${python3}" == "1" ]]; then 1910 elif [[ "${python3}" == "1" ]]; then
1785 PYTHON_ABI="$(eselect python show --python3 --ABI)" 1911 PYTHON_ABI="$(ROOT="/" eselect python show --python3 --ABI)"
1786 if [[ -z "${PYTHON_ABI}" ]]; then 1912 if [[ -z "${PYTHON_ABI}" ]]; then
1787 die "${FUNCNAME}(): Active version of CPython 3 not set" 1913 die "${FUNCNAME}(): Active version of CPython 3 not set"
1788 elif [[ "${PYTHON_ABI}" != "3."* ]]; then 1914 elif [[ "${PYTHON_ABI}" != "3."* ]]; then
1789 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`" 1915 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
1790 fi 1916 fi
1819 else 1945 else
1820 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1946 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1821 python_interpreter="python${PYTHON_ABI}" 1947 python_interpreter="python${PYTHON_ABI}"
1822 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1948 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1823 python_interpreter="jython${PYTHON_ABI%-jython}" 1949 python_interpreter="jython${PYTHON_ABI%-jython}"
1950 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
1951 python_interpreter="pypy-c${PYTHON_ABI#*-pypy-}"
1824 fi 1952 fi
1825 1953
1826 if [[ "${absolute_path_output}" == "1" ]]; then 1954 if [[ "${absolute_path_output}" == "1" ]]; then
1827 echo -n "${EPREFIX}/usr/bin/${python_interpreter}" 1955 echo -n "${EPREFIX}/usr/bin/${python_interpreter}"
1828 else 1956 else
1921 if [[ "${EAPI:-0}" == "0" ]]; then 2049 if [[ "${EAPI:-0}" == "0" ]]; then
1922 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2050 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1923 echo "=dev-lang/python-${PYTHON_ABI}*" 2051 echo "=dev-lang/python-${PYTHON_ABI}*"
1924 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2052 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1925 echo "=dev-java/jython-${PYTHON_ABI%-jython}*" 2053 echo "=dev-java/jython-${PYTHON_ABI%-jython}*"
2054 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2055 echo "=dev-python/pypy-${PYTHON_ABI#*-pypy-}*"
1926 fi 2056 fi
1927 else 2057 else
1928 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2058 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1929 echo "dev-lang/python:${PYTHON_ABI}" 2059 echo "dev-lang/python:${PYTHON_ABI}"
1930 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2060 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1931 echo "dev-java/jython:${PYTHON_ABI%-jython}" 2061 echo "dev-java/jython:${PYTHON_ABI%-jython}"
2062 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2063 echo "dev-python/pypy:${PYTHON_ABI#*-pypy-}"
1932 fi 2064 fi
1933 fi 2065 fi
1934} 2066}
1935 2067
1936# @FUNCTION: python_get_includedir 2068# @FUNCTION: python_get_includedir
1983 2115
1984 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2116 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1985 echo "${prefix}usr/include/python${PYTHON_ABI}" 2117 echo "${prefix}usr/include/python${PYTHON_ABI}"
1986 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2118 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1987 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include" 2119 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include"
2120 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2121 echo "${prefix}usr/$(get_libdir)/pypy${PYTHON_ABI#*-pypy-}/include"
1988 fi 2122 fi
1989} 2123}
1990 2124
1991# @FUNCTION: python_get_libdir 2125# @FUNCTION: python_get_libdir
1992# @USAGE: [-b|--base-path] [-f|--final-ABI] 2126# @USAGE: [-b|--base-path] [-f|--final-ABI]
1993# @DESCRIPTION: 2127# @DESCRIPTION:
1994# Print path to Python library directory. 2128# Print path to Python standard library directory.
1995# If --base-path option is specified, then path not prefixed with "/" is printed. 2129# If --base-path option is specified, then path not prefixed with "/" is printed.
1996# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2130# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1997python_get_libdir() { 2131python_get_libdir() {
1998 _python_check_python_pkg_setup_execution 2132 _python_check_python_pkg_setup_execution
1999 2133
2038 2172
2039 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2173 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2040 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}" 2174 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}"
2041 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2175 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2042 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib" 2176 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib"
2177 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2178 die "${FUNCNAME}(): PyPy has multiple standard library directories"
2043 fi 2179 fi
2044} 2180}
2045 2181
2046# @FUNCTION: python_get_sitedir 2182# @FUNCTION: python_get_sitedir
2047# @USAGE: [-b|--base-path] [-f|--final-ABI] 2183# @USAGE: [-b|--base-path] [-f|--final-ABI]
2050# If --base-path option is specified, then path not prefixed with "/" is printed. 2186# If --base-path option is specified, then path not prefixed with "/" is printed.
2051# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2187# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2052python_get_sitedir() { 2188python_get_sitedir() {
2053 _python_check_python_pkg_setup_execution 2189 _python_check_python_pkg_setup_execution
2054 2190
2055 local final_ABI="0" options=() 2191 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2056 2192
2057 while (($#)); do 2193 while (($#)); do
2058 case "$1" in 2194 case "$1" in
2059 -b|--base-path) 2195 -b|--base-path)
2060 options+=("$1") 2196 base_path="1"
2061 ;; 2197 ;;
2062 -f|--final-ABI) 2198 -f|--final-ABI)
2063 final_ABI="1" 2199 final_ABI="1"
2064 options+=("$1")
2065 ;; 2200 ;;
2066 -*) 2201 -*)
2067 die "${FUNCNAME}(): Unrecognized option '$1'" 2202 die "${FUNCNAME}(): Unrecognized option '$1'"
2068 ;; 2203 ;;
2069 *) 2204 *)
2070 die "${FUNCNAME}(): Invalid usage" 2205 die "${FUNCNAME}(): Invalid usage"
2071 ;; 2206 ;;
2072 esac 2207 esac
2073 shift 2208 shift
2074 done 2209 done
2210
2211 if [[ "${base_path}" == "0" ]]; then
2212 prefix="/"
2213 fi
2075 2214
2076 if [[ "${final_ABI}" == "1" ]]; then 2215 if [[ "${final_ABI}" == "1" ]]; then
2077 if ! _python_package_supporting_installation_for_multiple_python_abis; then 2216 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2078 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 2217 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2079 fi 2218 fi
2219 PYTHON_ABI="$(PYTHON -f --ABI)"
2080 else 2220 else
2081 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then 2221 if _python_package_supporting_installation_for_multiple_python_abis; then
2222 if ! _python_abi-specific_local_scope; then
2082 die "${FUNCNAME}() should be used in ABI-specific local scope" 2223 die "${FUNCNAME}() should be used in ABI-specific local scope"
2083 fi 2224 fi
2225 else
2226 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2084 fi 2227 fi
2228 fi
2085 2229
2086 echo "$(python_get_libdir "${options[@]}")/site-packages" 2230 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2231 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}/site-packages"
2232 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2233 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib/site-packages"
2234 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2235 echo "${prefix}usr/$(get_libdir)/pypy${PYTHON_ABI#*-pypy-}/site-packages"
2236 fi
2087} 2237}
2088 2238
2089# @FUNCTION: python_get_library 2239# @FUNCTION: python_get_library
2090# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option] 2240# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option]
2091# @DESCRIPTION: 2241# @DESCRIPTION:
2148 else 2298 else
2149 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)" 2299 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)"
2150 fi 2300 fi
2151 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2301 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2152 die "${FUNCNAME}(): Jython does not have shared library" 2302 die "${FUNCNAME}(): Jython does not have shared library"
2303 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2304 die "${FUNCNAME}(): PyPy does not have shared library"
2153 fi 2305 fi
2154} 2306}
2155 2307
2156# @FUNCTION: python_get_version 2308# @FUNCTION: python_get_version
2157# @USAGE: [-f|--final-ABI] [--full] [--major] [--minor] [--micro] 2309# @USAGE: [-f|--final-ABI] [-l|--language] [--full] [--major] [--minor] [--micro]
2158# @DESCRIPTION: 2310# @DESCRIPTION:
2159# Print Python version. 2311# Print version of Python implementation.
2160# --full, --major, --minor and --micro options cannot be specified simultaneously. 2312# --full, --major, --minor and --micro options cannot be specified simultaneously.
2161# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed. 2313# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
2314# If --language option is specified, then version of Python language is printed.
2315# --language and --full options cannot be specified simultaneously.
2316# --language and --micro options cannot be specified simultaneously.
2162# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2317# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2163python_get_version() { 2318python_get_version() {
2164 _python_check_python_pkg_setup_execution 2319 _python_check_python_pkg_setup_execution
2165 2320
2166 local final_ABI="0" full="0" major="0" minor="0" micro="0" python_command 2321 local final_ABI="0" language="0" language_version full="0" major="0" minor="0" micro="0" PYTHON_ABI="${PYTHON_ABI}" python_command
2167 2322
2168 while (($#)); do 2323 while (($#)); do
2169 case "$1" in 2324 case "$1" in
2170 -f|--final-ABI) 2325 -f|--final-ABI)
2171 final_ABI="1" 2326 final_ABI="1"
2172 ;; 2327 ;;
2328 -l|--language)
2329 language="1"
2330 ;;
2173 --full) 2331 --full)
2174 full="1" 2332 full="1"
2175 ;; 2333 ;;
2176 --major) 2334 --major)
2177 major="1" 2335 major="1"
2189 die "${FUNCNAME}(): Invalid usage" 2347 die "${FUNCNAME}(): Invalid usage"
2190 ;; 2348 ;;
2191 esac 2349 esac
2192 shift 2350 shift
2193 done 2351 done
2194
2195 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
2196 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
2197 fi
2198
2199 if [[ "${full}" == "1" ]]; then
2200 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:3]))"
2201 elif [[ "${major}" == "1" ]]; then
2202 python_command="from sys import version_info; print(version_info[0])"
2203 elif [[ "${minor}" == "1" ]]; then
2204 python_command="from sys import version_info; print(version_info[1])"
2205 elif [[ "${micro}" == "1" ]]; then
2206 python_command="from sys import version_info; print(version_info[2])"
2207 else
2208 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
2209 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2210 echo "${PYTHON_ABI}"
2211 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2212 echo "${PYTHON_ABI%-jython}"
2213 fi
2214 return
2215 fi
2216 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
2217 fi
2218 2352
2219 if [[ "${final_ABI}" == "1" ]]; then 2353 if [[ "${final_ABI}" == "1" ]]; then
2220 if ! _python_package_supporting_installation_for_multiple_python_abis; then 2354 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2221 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 2355 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2222 fi 2356 fi
2223 "$(PYTHON -f)" -c "${python_command}"
2224 else 2357 else
2225 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then 2358 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
2226 die "${FUNCNAME}() should be used in ABI-specific local scope" 2359 die "${FUNCNAME}() should be used in ABI-specific local scope"
2227 fi 2360 fi
2361 fi
2362
2363 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
2364 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
2365 fi
2366
2367 if [[ "${language}" == "1" ]]; then
2368 if [[ "${final_ABI}" == "1" ]]; then
2369 PYTHON_ABI="$(PYTHON -f --ABI)"
2370 elif [[ -z "${PYTHON_ABI}" ]]; then
2371 PYTHON_ABI="$(PYTHON --ABI)"
2372 fi
2373 language_version="${PYTHON_ABI%%-*}"
2374 if [[ "${full}" == "1" ]]; then
2375 die "${FUNCNAME}(): '--language' and '--full' options cannot be specified simultaneously"
2376 elif [[ "${major}" == "1" ]]; then
2377 echo "${language_version%.*}"
2378 elif [[ "${minor}" == "1" ]]; then
2379 echo "${language_version#*.}"
2380 elif [[ "${micro}" == "1" ]]; then
2381 die "${FUNCNAME}(): '--language' and '--micro' options cannot be specified simultaneously"
2382 else
2383 echo "${language_version}"
2384 fi
2385 else
2386 if [[ "${full}" == "1" ]]; then
2387 python_command="import sys; print('.'.join(str(x) for x in getattr(sys, 'pypy_version_info', sys.version_info)[:3]))"
2388 elif [[ "${major}" == "1" ]]; then
2389 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[0])"
2390 elif [[ "${minor}" == "1" ]]; then
2391 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[1])"
2392 elif [[ "${micro}" == "1" ]]; then
2393 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[2])"
2394 else
2395 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
2396 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2397 echo "${PYTHON_ABI}"
2398 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2399 echo "${PYTHON_ABI%-jython}"
2400 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2401 echo "${PYTHON_ABI#*-pypy-}"
2402 fi
2403 return
2404 fi
2405 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
2406 fi
2407
2408 if [[ "${final_ABI}" == "1" ]]; then
2409 "$(PYTHON -f)" -c "${python_command}"
2410 else
2228 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}" 2411 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
2412 fi
2413 fi
2414}
2415
2416# @FUNCTION: python_get_implementation_and_version
2417# @USAGE: [-f|--final-ABI]
2418# @DESCRIPTION:
2419# Print name and version of Python implementation.
2420# If version of Python implementation is not bound to version of Python language, then
2421# version of Python language is additionally printed.
2422# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2423python_get_implementation_and_version() {
2424 _python_check_python_pkg_setup_execution
2425
2426 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
2427
2428 while (($#)); do
2429 case "$1" in
2430 -f|--final-ABI)
2431 final_ABI="1"
2432 ;;
2433 -*)
2434 die "${FUNCNAME}(): Unrecognized option '$1'"
2435 ;;
2436 *)
2437 die "${FUNCNAME}(): Invalid usage"
2438 ;;
2439 esac
2440 shift
2441 done
2442
2443 if [[ "${final_ABI}" == "1" ]]; then
2444 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2445 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2446 fi
2447 PYTHON_ABI="$(PYTHON -f --ABI)"
2448 else
2449 if _python_package_supporting_installation_for_multiple_python_abis; then
2450 if ! _python_abi-specific_local_scope; then
2451 die "${FUNCNAME}() should be used in ABI-specific local scope"
2452 fi
2453 else
2454 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2455 fi
2456 fi
2457
2458 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-[[:alnum:]]+-[[:digit:]]+\.[[:digit:]]+$ ]]; then
2459 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI##*-} (Python ${PYTHON_ABI%%-*})"
2460 else
2461 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI%%-*}"
2229 fi 2462 fi
2230} 2463}
2231 2464
2232# ================================================================================================ 2465# ================================================================================================
2233# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================ 2466# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================
2242_python_test_hook() { 2475_python_test_hook() {
2243 if [[ "$#" -ne 1 ]]; then 2476 if [[ "$#" -ne 1 ]]; then
2244 die "${FUNCNAME}() requires 1 argument" 2477 die "${FUNCNAME}() requires 1 argument"
2245 fi 2478 fi
2246 2479
2247 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${FUNCNAME[3]}_$1_hook")" == "function" ]]; then 2480 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${_PYTHON_TEST_FUNCTION}_$1_hook")" == "function" ]]; then
2248 "${FUNCNAME[3]}_$1_hook" 2481 "${_PYTHON_TEST_FUNCTION}_$1_hook"
2249 fi 2482 fi
2250} 2483}
2251 2484
2252# @FUNCTION: python_execute_nosetests 2485# @FUNCTION: python_execute_nosetests
2253# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 2486# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
2287 python_test_function() { 2520 python_test_function() {
2288 local evaluated_PYTHONPATH 2521 local evaluated_PYTHONPATH
2289 2522
2290 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2523 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2291 2524
2292 _python_test_hook pre 2525 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook pre
2293 2526
2294 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2527 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2295 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 2528 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2296 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?" 2529 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2297 else 2530 else
2298 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 2531 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2299 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?" 2532 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2300 fi 2533 fi
2301 2534
2302 _python_test_hook post 2535 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook post
2303 } 2536 }
2304 if _python_package_supporting_installation_for_multiple_python_abis; then 2537 if _python_package_supporting_installation_for_multiple_python_abis; then
2305 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2538 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2306 else 2539 else
2307 if [[ -n "${separate_build_dirs}" ]]; then 2540 if [[ -n "${separate_build_dirs}" ]]; then
2351 python_test_function() { 2584 python_test_function() {
2352 local evaluated_PYTHONPATH 2585 local evaluated_PYTHONPATH
2353 2586
2354 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2587 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2355 2588
2356 _python_test_hook pre 2589 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook pre
2357 2590
2358 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2591 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2359 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL} 2592 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
2360 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?" 2593 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?"
2361 else 2594 else
2362 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL} 2595 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL}
2363 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?" 2596 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?"
2364 fi 2597 fi
2365 2598
2366 _python_test_hook post 2599 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook post
2367 } 2600 }
2368 if _python_package_supporting_installation_for_multiple_python_abis; then 2601 if _python_package_supporting_installation_for_multiple_python_abis; then
2369 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2602 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2370 else 2603 else
2371 if [[ -n "${separate_build_dirs}" ]]; then 2604 if [[ -n "${separate_build_dirs}" ]]; then
2415 python_test_function() { 2648 python_test_function() {
2416 local evaluated_PYTHONPATH 2649 local evaluated_PYTHONPATH
2417 2650
2418 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2651 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2419 2652
2420 _python_test_hook pre 2653 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook pre
2421 2654
2422 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2655 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2423 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2656 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2424 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?" 2657 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2425 else 2658 else
2426 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2659 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2427 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?" 2660 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2428 fi 2661 fi
2429 2662
2430 _python_test_hook post 2663 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook post
2431 } 2664 }
2432 if _python_package_supporting_installation_for_multiple_python_abis; then 2665 if _python_package_supporting_installation_for_multiple_python_abis; then
2433 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2666 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2434 else 2667 else
2435 if [[ -n "${separate_build_dirs}" ]]; then 2668 if [[ -n "${separate_build_dirs}" ]]; then
2472 fi 2705 fi
2473 2706
2474 export PYTHONDONTWRITEBYTECODE="1" 2707 export PYTHONDONTWRITEBYTECODE="1"
2475} 2708}
2476 2709
2710_python_vecho() {
2711 [[ -z ${PORTAGE_VERBOSE} ]] || echo "$@"
2712}
2713
2477_python_clean_compiled_modules() { 2714_python_clean_compiled_modules() {
2478 _python_initialize_prefix_variables 2715 _python_initialize_prefix_variables
2479 _python_set_color_variables 2716 _python_set_color_variables
2480 2717
2481 [[ "${FUNCNAME[1]}" =~ ^(python_mod_optimize|python_mod_cleanup)$ ]] || die "${FUNCNAME}(): Invalid usage" 2718 [[ "${FUNCNAME[1]}" =~ ^(python_mod_optimize|python_mod_cleanup)$ ]] || die "${FUNCNAME}(): Invalid usage"
2494 2731
2495 if [[ "${EBUILD_PHASE}" == "postrm" ]]; then 2732 if [[ "${EBUILD_PHASE}" == "postrm" ]]; then
2496 # Delete empty child directories. 2733 # Delete empty child directories.
2497 find "${path}" -type d | sort -r | while read -r dir; do 2734 find "${path}" -type d | sort -r | while read -r dir; do
2498 if rmdir "${dir}" 2> /dev/null; then 2735 if rmdir "${dir}" 2> /dev/null; then
2499 echo "${_CYAN}<<< ${dir}${_NORMAL}" 2736 _python_vecho "<<< ${dir}"
2500 fi 2737 fi
2501 done 2738 done
2502 fi 2739 fi
2503 elif [[ "${path}" == *.py ]]; then 2740 elif [[ "${path}" == *.py ]]; then
2504 base_module_name="${path##*/}" 2741 base_module_name="${path##*/}"
2527 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then 2764 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2528 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue 2765 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2529 else 2766 else
2530 [[ -f "${py_file}" ]] && continue 2767 [[ -f "${py_file}" ]] && continue
2531 fi 2768 fi
2532 echo "${_BLUE}<<< ${compiled_file%[co]}[co]${_NORMAL}" 2769 _python_vecho "<<< ${compiled_file%[co]}[co]"
2533 rm -f "${compiled_file%[co]}"[co] 2770 rm -f "${compiled_file%[co]}"[co]
2534 elif [[ "${compiled_file}" == *\$py.class ]]; then 2771 elif [[ "${compiled_file}" == *\$py.class ]]; then
2535 if [[ "${dir}" == "__pycache__" ]]; then 2772 if [[ "${dir}" == "__pycache__" ]]; then
2536 base_module_name="${compiled_file##*/}" 2773 base_module_name="${compiled_file##*/}"
2537 base_module_name="${base_module_name%\$py.class}" 2774 base_module_name="${base_module_name%\$py.class}"
2542 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then 2779 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2543 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue 2780 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2544 else 2781 else
2545 [[ -f "${py_file}" ]] && continue 2782 [[ -f "${py_file}" ]] && continue
2546 fi 2783 fi
2547 echo "${_BLUE}<<< ${compiled_file}${_NORMAL}" 2784 _python_vecho "<<< ${compiled_file}"
2548 rm -f "${compiled_file}" 2785 rm -f "${compiled_file}"
2549 else 2786 else
2550 die "${FUNCNAME}(): Unrecognized file type: '${compiled_file}'" 2787 die "${FUNCNAME}(): Unrecognized file type: '${compiled_file}'"
2551 fi 2788 fi
2552 2789
2553 # Delete empty parent directories. 2790 # Delete empty parent directories.
2554 dir="${compiled_file%/*}" 2791 dir="${compiled_file%/*}"
2555 while [[ "${dir}" != "${root}" ]]; do 2792 while [[ "${dir}" != "${root}" ]]; do
2556 if rmdir "${dir}" 2> /dev/null; then 2793 if rmdir "${dir}" 2> /dev/null; then
2557 echo "${_CYAN}<<< ${dir}${_NORMAL}" 2794 _python_vecho "<<< ${dir}"
2558 else 2795 else
2559 break 2796 break
2560 fi 2797 fi
2561 dir="${dir%/*}" 2798 dir="${dir%/*}"
2562 done 2799 done
2579 _python_check_python_pkg_setup_execution 2816 _python_check_python_pkg_setup_execution
2580 _python_initialize_prefix_variables 2817 _python_initialize_prefix_variables
2581 2818
2582 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then 2819 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
2583 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs. 2820 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs.
2584 local allow_evaluated_non_sitedir_paths="0" dir dirs=() evaluated_dirs=() evaluated_files=() file files=() iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_dirs=() site_packages_files=() 2821 local allow_evaluated_non_sitedir_paths="0" dir dirs=() evaluated_dirs=() evaluated_files=() file files=() iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_dirs=() site_packages_files=() stderr stderr_line
2585 2822
2586 if _python_package_supporting_installation_for_multiple_python_abis; then 2823 if _python_package_supporting_installation_for_multiple_python_abis; then
2587 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then 2824 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
2588 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called" 2825 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2589 fi 2826 fi
2684 options+=("-q") 2921 options+=("-q")
2685 2922
2686 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 2923 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2687 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then 2924 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then
2688 return_code="0" 2925 return_code="0"
2926 stderr=""
2689 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)" 2927 ebegin "Compilation and optimization of Python modules for $(python_get_implementation_and_version)"
2690 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then 2928 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then
2691 for dir in "${site_packages_dirs[@]}"; do 2929 for dir in "${site_packages_dirs[@]}"; do
2692 dirs+=("${root}$(python_get_sitedir)/${dir}") 2930 dirs+=("${root}$(python_get_sitedir)/${dir}")
2693 done 2931 done
2694 for dir in "${evaluated_dirs[@]}"; do 2932 for dir in "${evaluated_dirs[@]}"; do
2695 eval "dirs+=(\"\${root}${dir}\")" 2933 eval "dirs+=(\"\${root}${dir}\")"
2696 done 2934 done
2697 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" || return_code="1" 2935 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m compileall "${options[@]}" "${dirs[@]}" 2>&1)" || return_code="1"
2698 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2936 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2699 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1" 2937 "$(PYTHON)" -O -m compileall "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1"
2700 fi 2938 fi
2701 _python_clean_compiled_modules "${dirs[@]}" 2939 _python_clean_compiled_modules "${dirs[@]}"
2702 fi 2940 fi
2703 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then 2941 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then
2704 for file in "${site_packages_files[@]}"; do 2942 for file in "${site_packages_files[@]}"; do
2705 files+=("${root}$(python_get_sitedir)/${file}") 2943 files+=("${root}$(python_get_sitedir)/${file}")
2706 done 2944 done
2707 for file in "${evaluated_files[@]}"; do 2945 for file in "${evaluated_files[@]}"; do
2708 eval "files+=(\"\${root}${file}\")" 2946 eval "files+=(\"\${root}${file}\")"
2709 done 2947 done
2710 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" || return_code="1" 2948 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m py_compile "${files[@]}" 2>&1)" || return_code="1"
2711 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2949 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2712 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" &> /dev/null || return_code="1" 2950 "$(PYTHON)" -O -m py_compile "${files[@]}" &> /dev/null || return_code="1"
2713 fi 2951 fi
2714 _python_clean_compiled_modules "${files[@]}" 2952 _python_clean_compiled_modules "${files[@]}"
2715 fi 2953 fi
2716 eend "${return_code}" 2954 eend "${return_code}"
2955 if [[ -n "${stderr}" ]]; then
2956 eerror "Syntax errors / warnings in Python modules for $(python_get_implementation_and_version):" &> /dev/null
2957 while read stderr_line; do
2958 eerror " ${stderr_line}"
2959 done <<< "${stderr}"
2960 fi
2717 fi 2961 fi
2718 unset dirs files 2962 unset dirs files
2719 done 2963 done
2720 2964
2721 if _python_package_supporting_installation_for_multiple_python_abis; then 2965 if _python_package_supporting_installation_for_multiple_python_abis; then
2727 fi 2971 fi
2728 fi 2972 fi
2729 2973
2730 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then 2974 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
2731 return_code="0" 2975 return_code="0"
2976 stderr=""
2732 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version)" 2977 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation_and_version)"
2733 if ((${#other_dirs[@]})); then 2978 if ((${#other_dirs[@]})); then
2734 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1" 2979 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m compileall "${options[@]}" "${other_dirs[@]}" 2>&1)" || return_code="1"
2735 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2980 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2736 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1" 2981 "$(PYTHON ${PYTHON_ABI})" -O -m compileall "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
2737 fi 2982 fi
2738 _python_clean_compiled_modules "${other_dirs[@]}" 2983 _python_clean_compiled_modules "${other_dirs[@]}"
2739 fi 2984 fi
2740 if ((${#other_files[@]})); then 2985 if ((${#other_files[@]})); then
2741 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1" 2986 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m py_compile "${other_files[@]}" 2>&1)" || return_code="1"
2742 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2987 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2743 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1" 2988 "$(PYTHON ${PYTHON_ABI})" -O -m py_compile "${other_files[@]}" &> /dev/null || return_code="1"
2744 fi 2989 fi
2745 _python_clean_compiled_modules "${other_files[@]}" 2990 _python_clean_compiled_modules "${other_files[@]}"
2746 fi 2991 fi
2747 eend "${return_code}" 2992 eend "${return_code}"
2993 if [[ -n "${stderr}" ]]; then
2994 eerror "Syntax errors / warnings in Python modules placed outside of site-packages directories for $(python_get_implementation_and_version):" &> /dev/null
2995 while read stderr_line; do
2996 eerror " ${stderr_line}"
2997 done <<< "${stderr}"
2998 fi
2748 fi 2999 fi
2749 else 3000 else
2750 # Deprecated part of python_mod_optimize() 3001 # Deprecated part of python_mod_optimize()
2751 ewarn 3002 ewarn
2752 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation" 3003 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
2928} 3179}
2929 3180
2930# ================================================================================================ 3181# ================================================================================================
2931# ===================================== DEPRECATED FUNCTIONS ===================================== 3182# ===================================== DEPRECATED FUNCTIONS =====================================
2932# ================================================================================================ 3183# ================================================================================================
3184
3185fi # _PYTHON_ECLASS_INHERITED

Legend:
Removed from v.1.116  
changed lines
  Added in v.1.162

  ViewVC Help
Powered by ViewVC 1.1.20